"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalize = exports.parse = exports.stringify = void 0;
const stableStringify = require("fast-json-stable-stringify");
const UNDEFINED = 'undefined';
function stringify(input) {
    return input === undefined ? UNDEFINED : stableStringify(input);
}
exports.stringify = stringify;
function parse(input) {
    return input === UNDEFINED ? undefined : JSON.parse(input);
}
exports.parse = parse;
function normalize(input, { parse: parser = parse } = {}) {
    let result;
    if (normalize.cache.has(input)) {
        result = normalize.cache.get(input);
    }
    else {
        const data = parser(input);
        result = stringify(data);
        if (result === input)
            result = undefined;
        normalize.cache.set(input, result);
    }
    return result === undefined ? input : result;
}
exports.normalize = normalize;
(function (normalize) {
    normalize.cache = new Map();
})(normalize = exports.normalize || (exports.normalize = {}));
