"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sha1 = exports.cache = void 0;
const crypto_1 = require("crypto");
exports.cache = Object.create(null);
function sha1(...data) {
    const canCache = data.length === 1 && typeof data[0] === 'string';
    let cacheKey;
    if (canCache) {
        cacheKey = data[0];
        if (cacheKey in exports.cache) {
            return exports.cache[cacheKey];
        }
    }
    const hash = crypto_1.createHash('sha1');
    data.forEach((item) => {
        if (typeof item === 'string')
            hash.update(item, 'utf8');
        else
            hash.update(item);
    });
    const res = hash.digest('hex').toString();
    if (canCache) {
        exports.cache[cacheKey] = res;
    }
    return res;
}
exports.sha1 = sha1;
