"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TSError = exports.INSPECT_CUSTOM = void 0;
const make_error_1 = require("make-error");
const util_1 = require("util");
const logger_1 = require("./logger");
const messages_1 = require("./messages");
const logger = logger_1.rootLogger.child({ namespace: 'TSError' });
exports.INSPECT_CUSTOM = util_1.inspect.custom || 'inspect';
class TSError extends make_error_1.BaseError {
    constructor(diagnosticText, diagnosticCodes) {
        super(messages_1.interpolate("{{diagnostics}}", {
            diagnostics: diagnosticText.trim(),
        }));
        this.diagnosticText = diagnosticText;
        this.diagnosticCodes = diagnosticCodes;
        this.name = 'TSError';
        logger.debug({ diagnosticCodes, diagnosticText }, 'created new TSError');
        Object.defineProperty(this, 'stack', { value: '' });
    }
    [exports.INSPECT_CUSTOM]() {
        return this.diagnosticText;
    }
}
exports.TSError = TSError;
